//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "d"
#property link      "d"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Yellow

//---- input parameters
extern int ATRfast=80;
extern int ATRslow=20;

//---- buffers
double AtrBuffer_fast[];
double TempBuffer_fast[];
double AtrBuffer_slow[];
double TempBuffer_slow[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name_fast;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(2);
//---- indicator line
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,AtrBuffer_fast);
   SetIndexBuffer(3,TempBuffer_fast);
//---- name for DataWindow and indicator subwindow label
   short_name_fast="ATR("+ATRfast+")";
   IndicatorShortName(short_name_fast);
   SetIndexLabel(2,short_name_fast);
//----
   SetIndexDrawBegin(2,ATRfast);
//----

//-------------------------------------------------------------------

   string short_name_slow;
//---- 1 additional buffer used for counting.
  IndicatorBuffers(2);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,AtrBuffer_slow);
   SetIndexBuffer(1,TempBuffer_slow);
//---- name for DataWindow and indicator subwindow label
   short_name_slow="ATR("+ATRslow+")";
   IndicatorShortName(short_name_slow);
   SetIndexLabel(0,short_name_slow);
//----
   SetIndexDrawBegin(0,ATRslow);
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=ATRfast) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=ATRfast;i++) AtrBuffer_fast[Bars-i]=0.0;
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) TempBuffer_fast[i]=high-low;
      else
        {
         double prevclose=Close[i+1];
         TempBuffer_fast[i]=MathMax(high,prevclose)-MathMin(low,prevclose);
        }
      i--;
     }
//----
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   for(i=0; i<limit; i++)
      AtrBuffer_fast[i]=iMAOnArray(TempBuffer_fast,Bars,ATRfast,0,MODE_SMA,i);










   int j,counted_bars_slow=IndicatorCounted();
//----
   if(Bars<=ATRslow) return(0);
//---- initial zero
   if(counted_bars<1)
      for(j=1;j<=ATRslow;j++) AtrBuffer_slow[Bars-j]=0.0;
//----
   j=Bars-counted_bars-1;
   while(j>=0)
     {
      double high_slow=High[j];
      double low_slow =Low[j];
      if(j==Bars-1) TempBuffer_slow[j]=high-low;
      else
        {
         double prevclose_slow=Close[j+1];
         TempBuffer_slow[j]=MathMax(high_slow,prevclose_slow)-MathMin(low_slow,prevclose_slow);
        }
      j--;
     }
//----
   if(counted_bars_slow>0) counted_bars_slow--;
   int limit_slow=Bars-counted_bars_slow;
   for(j=0; j<limit_slow; j++)
      AtrBuffer_slow[j]=iMAOnArray(TempBuffer_slow,Bars,ATRslow,0,MODE_SMA,j);
















//----
   return(0);
  }
//+------------------------------------------------------------------+